<?php
// contains common functions of the lmo module for use with drupal 5 and drupal 6

function lmo_help($section) {
  switch ($section) {
    case 'admin/modules#description':
      return t('Integrates the famous LigaManagerOnline into drupal 6');
  }
}

function lmo_perm() {
  return array('administer lmo');
}

function lmo_settings_form() {

$form['lmo_local_path'] = array(
    '#type' => 'textfield',
    '#title' => t('local LMO path'),
    '#default_value' => variable_get('lmo_local_path', 'Default setting'),
   /* '#size' => 20,*/
    '#maxlength' => 255,
    '#description' => t('Path to your local lmo installation.'),
  );
  
 $form['lmo_admin'] = array(
    '#type' => 'textfield',
    '#title' => t('lmo admin username'),
    '#default_value' => variable_get('lmo_admin', 'admin'),
   /* '#size' => 20,*/
    '#maxlength' => 255,
    '#description' => t('Give the username of an administrator created in LMO.'),
  );

 $form['lmo_admin_pass'] = array(
    '#type' => 'password',
    '#title' => t('lmo admin pasword'),
    '#default_value' => variable_get('lmo_admin_pass', 'lmo'),
   /* '#size' => 20,*/
    '#maxlength' => 255,
    '#description' => t('Give the password of the user above.'),
  );
  return system_settings_form($form); 
}

function lmo_page(){
  drupal_add_css(drupal_get_path('module', 'lmo').'/lmo.css');
  $bc = array();
  $bc[] = l(t('Home'), '');
  if ($_GET['file'] != '') {
     $bc[] = l(t('League Manager Online'), 'lmo');
  }
  if ($_GET['action'] != '') {
     $bc[] = l($_GET['file'], 'lmo', array(), 'file='.$_GET['file']);
  }
  drupal_set_breadcrumb($bc);
  drupal_set_title('');
  $_SESSION["lmouserok"] = 0;
  if (!isset($_SESSION["lmouserlang"])){ $_SESSION["lmouserlang"] = "English";};
  ob_start();
  require(variable_get('lmo_local_path','').'/lmo-start.php');
  $content = ob_get_contents();
  ob_end_clean();
  $content = lmo_rework_lmo_output($content);
  print theme('page', $content);
}

function lmo_page_backend() {
  $lmo_path= variable_get('lmo_local_path','');
  $lmo_url = str_replace($_SERVER['DOCUMENT_ROOT'], '', $lmo_path);
  $lmo_url = substr($lmo_url,1); 
  drupal_set_message(t('The lmo backend in drupal is still broken in some cases, so please use the original backend at').' '.l($lmo_url.'/lmoadmin.php',$lmo_url.'/lmoadmin.php').'!');
 drupal_add_css(drupal_get_path('module', 'lmo').'/lmo.css');
 drupal_set_title(t('LMO Backend'));
 $dirligen= 'test';
 ob_start();
	define('LMO_AUTH', 1);
	require($lmo_path.'/init.php');
	
	$subdir='';
	if(!isset($_SESSION["lmouserfile"])){$_SESSION["lmouserfile"]="";}
    if(!isset($_SESSION["lmouserokerweitert"])){$_SESSION["lmouserokerweitert"]=0;}
	
	$_POST["xusername"] = variable_get('lmo_admin', '');
	$_POST["xuserpass"] = variable_get('lmo_admin_pass', '');
	$_SESSION["lmouserok"] = 0;
	
	$todo=isset($_REQUEST['todo'])?$_REQUEST['todo']:"";
    $st=isset($_REQUEST['st'])?$_REQUEST['st']:NULL;
    if($todo=="logout"){
    		$_SESSION['lmouserok']=0;
    		$_SESSION['lmouserpass']="";
  	}
  
    $action="admin";
    $array = array();

    if (($todo == 'delete') || ($todo == 'download'))
	{	
		$dirliga = $lmo_path.'/'.$dirliga;
	}

    require(variable_get('lmo_local_path','').'/lmo-admincheck_auth.php');
	$file=!empty($_REQUEST['file'])?$_REQUEST['file']:'';

    if (!empty($file) && ($todo=="open" || $todo=="")) $todo="edit";
    if ((!empty($file) && check_hilfsadmin($file)) || empty($file))  require(variable_get('lmo_local_path','').'/lmo-adminmain.php');
	$content = ob_get_contents();
	ob_end_clean();
	
	if (variable_get('clean_url',0) == 1) {
		$content = str_replace('index.php', 'admin/content/lmo', $content);
	} else {
		$content = str_replace('index.php?', 'index.php?q=admin/content/lmo&', $content);
		$content = str_replace('index.php"', 'index.php?q=admin/content/lmo"', $content);
		//drupal_set_message(t("Sorry ... forms in admin section doesn't work without clean_url enabled yet!"), 'error');
	}
	
	$content = utf8_encode($content);
	print theme('page', $content);
}

function lmo_rework_lmo_output($input) {
	$content = $input;
	$lmo_path= variable_get('lmo_local_path','');
	$lmo_url = str_replace($_SERVER['DOCUMENT_ROOT'], '', $lmo_path);
	if (variable_get('clean_url',0) == 1) {
		$content = str_replace($lmo_url.'/?', '/lmo?', $content);	
    $content = str_replace('index.php', 'lmo', $content);
  } else {
    $content = str_replace($lmo_url.'/?', '/index.php?q=lmo&', $content);
  	$content = str_replace('index.php?', 'index.php?q=lmo&', $content);
    $content = str_replace("index.php'", "index.php?q=lmo'", $content);
  }
  return utf8_encode($content);
}


function lmo_getblocksdata() {
  $blocks = array();
  $sql = "SELECT * FROM {lmo_blocks}";
	$result = db_query($sql);
  while ($block = db_fetch_object($result)) {
    $blocks[$block->id]['delta'] = $block->id;
    $blocks[$block->id]['type'] = $block->type;
    $blocks[$block->id]['option1'] = $block->option1;
    $blocks[$block->id]['option2'] = $block->option2;
    $blocks[$block->id]['option3'] = $block->option3;
    $blocks[$block->id]['title'] = $block->title;
    $blocks[$block->id]['intro'] = $block->intro;
    $blocks[$block->id]['conclusion'] = $block->conclusion;
  }
  return $blocks;
}

function lmo_getblock($id) {
  $sql = "SELECT * FROM {lmo_blocks} WHERE id='".$id."'";
  $result = db_query($sql);
  $blockdata = db_fetch_object($result);
	$block['delta'] = $blockdata->id;
	$block['type'] = $blockdata->type;
	$block['option1'] = $blockdata->option1;
	$block['option2'] = $blockdata->option2;
	$block['option3'] = $blockdata->option3;
	$block['title'] = $blockdata->title;
	$block['intro'] = $blockdata->intro;
	$block['conclusion'] = $blockdata->conclusion;
  return $block;
}

function lmo_check_blockstatus ($block, $verbose = false) {
  $status = array();
  switch ($block['type']) {
  	case 'minitab':
  		$status['ok'] = true;
  		if ($block['option1'] == '') {
  			$status['message'] = t('No league file provided!').'<br>';
  			$status['ok'] = false;
  		}
  		if ($block['option2'] == '') {
  			$status['message'] .= t('No template file provided!').'<br>';
        $status['ok'] = false;
  		}
  		$status['visible'] = false;
  		break;
  	default:
  		$status['ok'] = false;
      $status['visible'] = false;
      $status['message'] = t('This type of block is not supported yet.');
  }
	return $status;
}

function lmo_block($op = 'list', $delta = 0) {
  $blockarray = lmo_getblocksdata();
  if ($op == 'list') {
    foreach ($blockarray as $blockdata)
    {
      $blocks[$blockdata['delta']]['info'] = 'LMO:'.$blockdata['type'].':'.$blockdata['option1'];
    }
    return $blocks;
  }
  else if ($op == 'view' && user_access('access content')) {
    switch ($blockarray[$delta]['type']) {
      case 'minitab':
        if ($blockarray[$delta]['title'] != '') {
          $block['subject'] = $blockarray[$delta]['title'];
        } else $block['subject'] = t('Standings').' '.$blockarray[$delta]['option1'];
        $block['content'] = get_minitab_block_content($blockarray[$delta]);//theme('minitab_block', $blockarray[$delta]);		
		break;
      default:
        $block['subject'] = t('No Block');
        $block['content'] = t('There is no content in no block!');
    }
    return $block;
  }
}

function get_minitab_block_content ($blockdata) {
  $lmopath = variable_get('lmo_local_path','');
  $output = '';
  if ($blockdata['intro'] != '') $output .= $blockdata['intro']; 
  $mini_liga = $blockdata['option1'];
  $mini_template = $blockdata['option2'];
  $mini_unter=100;
  $mini_platz=1;
  require($lmopath.'/init.php');
  ob_start();
  include($lmopath.'/addon/mini/lmo-minitab.php');
  $table = ob_get_contents();
  $output .= lmo_rework_lmo_output($table);
  ob_end_clean();
  if ($blockdata['conclusion'] != '') $output .= $blockdata['conclusion'];
  return $output;
}

?>
